#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MAXN = 510000;
int a[MAXN];
int qx[MAXN];
int qy[MAXN];

void print(int n, int m) {
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			cout << " ";
		cout << a[i];
	}
	cout << "\n";
	for (int i = 0; i < m; ++i)
		cout << qx[i] << " " << qy[i] << "\n";
}

vector<int> vv;

int cnt = 0;
int GR;

void gen(int l, int r, int maxh) {
	sort(vv.begin() + l, vv.begin() + r);
	vector<int> pp;
	pp.push_back(l);
	for (int i = l + 2; i < r - 2; i += 2)
		pp.push_back(i);
	shuffle(pp.begin() + 2, pp.end());
	int k = rnd.next(10, 30);
	sort(pp.begin(), pp.begin() + k - 1);
	for (int i = 0; i < k - 1; ++i) {
		int p = r - k + i;
		int np = pp[i];
		rotate(vv.begin() + np, vv.begin() + p, vv.begin() + p + 1);
	}
	pp[k - 1] = r - 1;
	for (int i = 0; i < k - 1; ++i)
		reverse(vv.begin() + pp[i] + 1, vv.begin() + pp[i + 1]);
	for (int i = 0; i < GR / 10; ++i)
		qx[cnt] = l + 2, qy[cnt] = rnd.next(1, maxh), ++cnt;
}


int main(int argc, char **argv) {
	//Usage: n, m, maxh, GR, seed
	assert(argc == 6);
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int maxh = atoi(argv[3]);
	GR = atoi(argv[4]);
	assert(n >= GR);
	assert(GR % 2 == 0);
	assert(GR >= 100);
	n = (n / GR) * GR;
	for (int i = 0; i < n; ++i)
		vv.push_back(i + 1);

	reverse(vv.begin(), vv.end());

	for (int i = 0; i < n; i += GR)
		gen(i, i + GR, maxh);

	for (int i = cnt; i < m; ++i)
		qx[i] = rnd.next(1, n), qy[i] = rnd.next(1, maxh);

	for (int i = 0; i < n; ++i)
		a[i] = vv[i];

	print(n, m);
	return 0;
}


