#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MAXN = 510000;
int a[MAXN];
int qx[MAXN];
int qy[MAXN];

void print(int n, int m) {
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			cout << " ";
		cout << a[i];
	}
	cout << "\n";
	for (int i = 0; i < m; ++i)
		cout << qx[i] << " " << qy[i] << "\n";
}

void gen_eq(int n, int m, int maxh) {
	int h = rnd.next(2, maxh - 1);
	for (int i = 0; i < n; ++i)
		a[i] = h;
	for (int i = 0; i < m; ++i) {
		qx[i] = rnd.next(1, n);
		int k = rnd.next(1, 3);
		if (k == 1)
			qy[i] = h - 1;
		else if (k == 2)
			qy[i] = h + 1;
		else
			qy[i] = rnd.next(1, maxh);
	}
}

void gen_incr(int n, int m, int maxh) {
	vector<int> vv;
	for (int i = 0; i < n; ++i)
		vv.push_back(rnd.next(1, maxh));
	sort(vv.begin(), vv.end());
	for (int i = 0; i < n; ++i)
		a[i] = vv[i];
	int cnt = 0;
	if (a[0] > 1)
		qx[cnt] = 1, qy[cnt] = a[0] - 1, ++cnt;
	if (a[0] < maxh)
		qx[cnt] = 1, qy[cnt] = a[0] + 1, ++cnt;
	qx[cnt] = 1, qy[cnt] = rnd.next(1, maxh), ++cnt;
	if (a[n - 1] > 1)
		qx[cnt] = n, qy[cnt] = a[n - 1] - 1, ++cnt;
	if (a[n - 1] < maxh)
		qx[cnt] = n, qy[cnt] = a[n - 1] + 1, ++cnt;
	qx[cnt] = n, qy[cnt] = rnd.next(1, maxh), ++cnt;
	for (int i = cnt; i < m; ++i) {
		int k = rnd.next(1, 4);
		int x = rnd.next(1, n);
		if (k == 1 && a[x - 1] > 1)
			qx[i] = x, qy[i] = a[x - 1] - 1; 
		else if (k == 2 && a[x - 1] < maxh)
			qx[i] = x, qy[i] = a[x - 1] + 1;
		else
			qx[i] = x, qy[i] = rnd.next(1, maxh);
	}
}

void gen_decr(int n, int m, int maxh) {
	gen_incr(n, m, maxh);
	reverse(a, a + n);
	for (int i = 0; i < m; ++i)
		qx[i] = n + 1 - qx[i];
}


int main(int argc, char **argv) {
	//Usage: type, n, m, maxh, seed
	assert(argc == 6);
	registerGen(argc, argv, 1);
	int t = atoi(argv[1]);
	int n = atoi(argv[2]);
	int m = atoi(argv[3]);
	int maxh = atoi(argv[4]);
	switch (t) {
		case 1:
			gen_incr(n, m, maxh);
			break;
		case 2:
			gen_decr(n, m, maxh);
			break;
		case 3:
			gen_eq(n, m, maxh);
			break;
		default:
			assert(0);
	}
	print(n, m);
	return 0;
}


