#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 1000010;
const int MX = 1000010;
const int MOD = 1000000007;

struct node {
	node *l, *r;
	pair<int, int> ans;
	node() {
		l = r = 0;
		ans = make_pair(0, 0);
	}
};

node *build(int tl, int tr) {
	node *now = new node();
	if (tl + 1 == tr)
		return now;
	int m = (tl + tr) >> 1;
	now->l = build(tl, m);
	now->r = build(m, tr);
	return now;
}

pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
	if (a.first == b.first) {
		a.second += b.second;
		if (a.second >= MOD)
			a.second -= MOD;
		return a;
	}
	else
		return (a.first > b.first ? a : b);
}

node *upd(node *v, int tl, int tr, int x, pair<int, int> y) {
	node *now = new node();
	*now = *v;
	now->ans = merge(now->ans, y);
	if (tl + 1 == tr)
		return now;
	int m = (tl + tr) >> 1;
	if (x < m)
		now->l = upd(now->l, tl, m, x, y);
	else
		now->r = upd(now->r, m, tr, x, y);
	return now;
}

pair<int, int> get(node *v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return make_pair(0, 0);
	if (l <= tl && tr <= r)
		return v->ans;
	int m = (tl + tr) >> 1;
	return merge(get(v->l, tl, m, l, r), get(v->r, m, tr, l, r));
}

int n, m;
node *rmql[MAXN];
node *rmqr[MAXN];
int a[MAXN];
int fl[MAXN];

vector<int> cmpr;

int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i), cmpr.push_back(a[i]);
	sort(cmpr.begin(), cmpr.end());
	cmpr.resize(unique(cmpr.begin(), cmpr.end()) - cmpr.begin());
	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(cmpr.begin(), cmpr.end(), a[i]) - cmpr.begin() + 1;
	rmql[0] = rmqr[n - 1] = build(0, MX);
	for (int i = 0; i < n; ++i) {
		pair<int, int> go = get(rmql[i], 0, MX, 0, a[i]);
		if (go.first == 0)
			go.second = 1;
		++go.first;
		rmql[i + 1] = upd(rmql[i], 0, MX, a[i], go);
	}
	for (int i = n - 1; i > 0; --i) {
		pair<int, int> go = get(rmqr[i], 0, MX, a[i] + 1, MX);
		if (go.first == 0)
			go.second = 1;
		++go.first;
		rmqr[i - 1] = upd(rmqr[i], 0, MX, a[i], go);
	}
	pair<int, int> lis = get(rmql[n], 0, MX, 0, MX);

	for (int i = 0; i < n; ++i) {
		pair<int, int> gol = get(rmql[i], 0, MX, 0, a[i]);
		pair<int, int> gor = get(rmqr[i], 0, MX, a[i] + 1, MX);
		if (gol.first == 0)
			gol.second = 1;
		if (gor.first == 0)
			gor.second = 1;
		if (gol.first + 1 + gor.first == lis.first && ((ll)gol.second * (ll)gor.second) % MOD == lis.second)
			fl[i] = 1;
	}

	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		int ans = (fl[x] ? lis.first - 1 : lis.first);
		int g = lower_bound(cmpr.begin(), cmpr.end(), y) - cmpr.begin();
		pair<int, int> gol = get(rmql[x], 0, MX, 0, g + 1);
		if (g != (int)cmpr.size() && cmpr[g] == y)
			++g;
		pair<int, int> gor = get(rmqr[x], 0, MX, g + 1, MX);
		ans = max(ans, gol.first + 1 + gor.first);
		printf("%d\n", ans);
	}

	return 0;
}


