#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 3100;

int rmq[MAXN * 8];
int a[MAXN];
int n, m;
vector<int> vv;
int qx[MAXN];
int qy[MAXN];

void build(int v, int tl, int tr) {
	rmq[v] = 0;
	if (tl + 1 == tr)
		return;
	int m = (tl + tr) >> 1;
	build(v * 2 + 1, tl, m);
	build(v * 2 + 2, m, tr);
}

int get(int v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return 0;
	if (l <= tl && tr <= r)
		return rmq[v];
	int m = (tl + tr) >> 1;
	return max(get(v * 2 + 1, tl, m, l, r), get(v * 2 + 2, m, tr, l, r));
}

void upd(int v, int tl, int tr, int x, int y) {
	if (tl + 1 == tr) {
		rmq[v] = max(rmq[v], y);
		return;
	}
	int m = (tl + tr) >> 1;
	if (x < m)
		upd(v * 2 + 1, tl, m, x, y);
	else
		upd(v * 2 + 2, m, tr, x, y);
	rmq[v] = max(rmq[v * 2 + 1], rmq[v * 2 + 2]);
}

int solve() {
	build(0, 0, (int)vv.size() + 1);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int x = get(0, 0, (int)vv.size() + 1, 0, a[i]);
		ans = max(x + 1, ans);
		upd(0, 0, (int)vv.size() + 1, a[i], x + 1);
	}
	return ans;
}

int main() {
	cin >> n >> m;
	if (n >= MAXN || m >= MAXN) {
		while (true);
	}
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < n; ++i)
		vv.push_back(a[i]);
	for (int i = 0; i < m; ++i)
		cin >> qx[i] >> qy[i], vv.push_back(qy[i]);
	sort(vv.begin(), vv.end());
	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(vv.begin(), vv.end(), a[i]) - vv.begin() + 1;
	for (int i = 0; i < m; ++i)
		qy[i] = lower_bound(vv.begin(), vv.end(), qy[i]) - vv.begin() + 1;
	for (int i = 0; i < m; ++i) {
		int x, y;
		x = qx[i];
		y = qy[i];
		--x;
		int tmp = a[x];
		a[x] = y;
		cout << solve() << "\n";
		a[x] = tmp;
	}
	return 0;
}


