#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

struct Vertex {
    int tin;
    char visited;
    set<ll> edges;
    
    Vertex() : visited(0) {}
};

map<ll, Vertex> verteces;
int curr_time = 0;

void fail() {
    cout << "Impossible\n";
    exit(0);
}

void dfs(ll value) {
    map<ll, Vertex>::iterator iter = verteces.find(value);
    
    if (iter->second.visited == 2) {
        return;
    }
    if (iter->second.visited == 1) {
        fail();
    }
    iter->second.visited = 1;
    
    for (set<ll>::const_iterator it = iter->second.edges.begin(); it != iter->second.edges.end(); ++it) {
        dfs(*it);
    }
    
    iter->second.tin = curr_time++;
    iter->second.visited = 2;
}

template <typename Iter>
void insert(Iter begin, Iter end) {
    sort(begin, end);
    for (Iter it = begin; it != end - 1; ++it) {
        if (*it != *(it + 1)) {
            verteces[*it].edges.insert(*(it + 1));
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    
    vector<vector<ll> > matrix(n, vector<ll>(m));
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cin >> matrix[i][j];
            if (verteces.find(matrix[i][j]) == verteces.end()) {
                verteces[matrix[i][j]] = Vertex();
            }
        }
    }
    
    vector<ll> row(m), column(n);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            row[j] = matrix[i][j];
        }
        insert(row.begin(), row.end());
    }
    for (int j = 0; j != m; ++j) {
        for (int i = 0; i != n; ++i) {
            column[i] = matrix[i][j];
        }
        insert(column.begin(), column.end());
    }
    
    for (map<ll, Vertex>::const_iterator it = verteces.begin(); it != verteces.end(); ++it) {
        if (!it->second.visited) {
            dfs(it->first);
        }
    }
    
    //cout << curr_time << '\n';
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cout << n * m - verteces[matrix[i][j]].tin << ' ';
        }
        cout << '\n';
    }
    
    return 0;
}