#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>

using namespace std;

struct Vertex {
    int ans, size_in;
    char visited;
    vector<Vertex *> edges;
    
    Vertex() : visited(0), size_in(0) {}
};

unordered_map<int, Vertex *> verteces;

template <typename Iter>
void insert(Iter begin, Iter end) {
    sort(begin, end);
    for (Iter it = begin; it != end - 1; ++it) {
        Vertex *from = verteces[*it];
        Vertex *to = verteces[*(it + 1)];
        
        if (*it != *(it + 1)) {
            from->edges.push_back(to);
            ++to->size_in;
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    
    vector<vector<int> > matrix(n, vector<int>(m));
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cin >> matrix[i][j];
            if (verteces.find(matrix[i][j]) == verteces.end()) {
                verteces[matrix[i][j]] = new Vertex();
            }
        }
    }
    
    vector<int> row(m), column(n);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            row[j] = matrix[i][j];
        }
        insert(row.begin(), row.end());
    }
    for (int j = 0; j != m; ++j) {
        for (int i = 0; i != n; ++i) {
            column[i] = matrix[i][j];
        }
        insert(column.begin(), column.end());
    }
    
    
    vector<Vertex *> curr, next;
    
    for (unordered_map<int, Vertex *>::iterator it = verteces.begin(); it != verteces.end(); ++it) {
        if (!it->second->size_in) {
            curr.push_back((it->second));
        }
    }
    
    int level = 1;
    while (!curr.empty()) {
        while (!curr.empty()) {
            Vertex *vertex = curr.back();
            curr.pop_back();
            
            vertex->ans = level;
            
            for (vector<Vertex *>::const_iterator it = vertex->edges.begin(); it != vertex->edges.end(); ++it) {
                if (!(--(*it)->size_in)) {
                    next.push_back(*it);
                }
            }
        }
        
        ++level;
        curr.swap(next);
    }
    
    //cout << level - 1 << '\n';
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cout << verteces[matrix[i][j]]->ans << ' ';
        }
        cout << '\n';
    }
    
    return 0;
}