#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

vector<vector<int> > graph_eq, graph_less;
vector<int> in_size;

template <class Iter>
void add_edges(Iter begin, Iter end) {
    sort(begin, end);
    
    for (Iter it = begin; it != end - 1; ++it) {
        if (it->first == (it + 1)->first) {
            graph_eq[it->second].push_back((it + 1)->second);
            graph_eq[(it + 1)->second].push_back(it->second);
        } else {
            graph_less[it->second].push_back((it + 1)->second);
            ++in_size[(it + 1)->second];
        }
    }
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    
    vector<vector<int> > matrix(n, vector<int>(m));
    graph_eq.resize(n * m);
    graph_less.resize(n * m);
    in_size.resize(n * m, 0);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            scanf("%d", &matrix[i][j]);
        }
    }
    
    vector<pair<int, int> > row(m), column(n);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            row[j] = make_pair(matrix[i][j], i * m + j);
        }
        add_edges(row.begin(), row.end());
    }
    for (int j = 0; j != m; ++j) {
        for (int i = 0; i != n; ++i) {
            column[i] = make_pair(matrix[i][j], i * m + j);
        }
        add_edges(column.begin(), column.end());
    }
    
    vector<int> curr, next;
    vector<char> added(n * m, 0);
    for (int i = 0; i != n * m; ++i) {
        if (!in_size[i]) {
            curr.push_back(i);
            added[i] = true;
        }
    }
    
    int level = 1;
    while (!curr.empty()) {
        while (!curr.empty()) {
            int v = curr.back();
            curr.pop_back();
            matrix[v / m][v % m] = level;
            
            for (vector<int>::const_iterator it = graph_eq[v].begin(); it != graph_eq[v].end(); ++it) {
                if (!in_size[*it] && !added[*it]) {
                    curr.push_back(*it);
                    added[*it] = true;
                }
            }
            for (vector<int>::const_iterator it = graph_less[v].begin(); it != graph_less[v].end(); ++it) {
                --in_size[*it];
                if (!in_size[*it]) {
                    next.push_back(*it);
                    added[*it] = true;
                }
            }
        }
        
        curr.swap(next);
        ++level;
    }
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            printf("%d ", matrix[i][j]);
        }
        printf("\n");
    }
    
    return 0;
}