#include <iostream>
#include <unistd.h>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#undef NDEBUG
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <tuple>

using namespace std;

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define pbk pop_back
#define sz(s) ((int) (s).size())
#define len(s) sz(s)
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#define cerr if (0) cerr
#endif
#if _WIN32 || __WIN32__ || _WIN64 || __WIN64__
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#define prev huprev
#define next hunext
#define link hulink
#define hash huhash
#define rank hurank
#define y0 yy0
#define y1 yy1

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
typedef long double ldouble;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = 1e9;
const double eps = 1e-9;
const double pi = 4 * atan(1.0);
const int N = int(5e5) + 100;
const int LOG = 20;

int prev[N], h[N], x[N], y[N], rank[N], gpar[N], par[N];
int p[LOG][N];
vi g[N];
vector<tuple<int, int, int, int> > ans;

void dfs(int v, int pv = -1) {
    if (pv != -1) {
        g[v].erase(find(all(g[v]), pv));
    }
    par[v] = pv;
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

int get(int a) {
    if (prev[a] != a) {
        prev[a] = get(prev[a]);
    }
    return prev[a];
}

inline void merge(int a, int b, int c) {
    if (rank[a] < rank[b]) {
        swap(a, b);
    }
    prev[b] = a;
    if (rank[a] == rank[b]) {
        ++rank[a];
    }
    gpar[a] = c;
}

void go(int v) {
    if (par[v] != -1) {
        int x = get(v), y = get(par[v]);
        if (x != y) {
            merge(x, y, gpar[y]);
        }
    }
}

inline int get_lca(int a, int b) {
    if (h[a] < h[b]) {
        swap(a, b);
    }
    for (int i = LOG - 1; i >= 0; --i) {
        if (p[i][a] != -1 && h[p[i][a]] >= h[b]) {
            a = p[i][a];
        }
    }
    if (a == b) {
        return a;
    }
    for (int i = LOG - 1; i >= 0; --i) {
        if (p[i][a] != p[i][b]) {
            a = p[i][a];
            b = p[i][b];
        }
    }
    return p[0][a];
}

int main() {
#ifdef LOCAL42
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        scanf("%d %d", &a, &b);
        --a;
        --b;
        g[a].pb(b);
        g[b].pb(a);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        p[0][i] = par[i];
    }
    for (int i = 1; i < LOG; ++i) {
        for (int j = 0; j < n; ++j) {
            if (p[i - 1][j] == -1) {
                p[i][j] = -1;
            } else {
                p[i][j] = p[i - 1][p[i - 1][j]];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        prev[i] = i;
        rank[i] = 1;
        gpar[i] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        scanf("%d %d", x + i, y + i);
        --x[i];
        --y[i];
        if (par[x[i]] == y[i]) {
            go(x[i]);
        } else if (par[y[i]] == x[i]) {
            go(y[i]);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (par[x[i]] == y[i] || par[y[i]] == x[i]) {
            continue;
        }
        int z = get_lca(x[i], y[i]);
        int gx = gpar[get(x[i])], gy = gpar[get(y[i])];
        if (h[gx] > h[z]) {
            ans.emplace_back(gx, par[gx], x[i], y[i]);
            go(gx);
        } else if (h[gy] > h[z]) {
            ans.emplace_back(gy, par[gy], x[i], y[i]);
            go(gy);
        } else {
            assert(false);
        }
    }
    cout << sz(ans) << endl;
    for (tuple<int, int, int, int> t : ans) {
        int a, b, c, d;
        tie(a, b, c, d) = t;
        printf("%d %d %d %d\n", a + 1, b + 1, c + 1, d + 1);
    }
    return 0;
}
