#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>
#include <tuple>
using namespace std;

int n;

const int N = 500500;
vector<int> E[N];
int used[N];
int curver = 0;

int DFS(int x, int p = -1) {
    int cnt = 1;
    used[x] = curver;
    for (int y : E[x]) {
        if (y == p)
            continue;
        if (used[y] == curver)
            continue;
        cnt += DFS(y, x);
    }
    return cnt;
}

bool is_tree(vector<pair<int, int>> edges) {
    ++curver;
    for (int i = 1; i <= n; i++)
        E[i].clear();
    for (auto ed : edges) {
        int a, b;
        tie(a, b) = ed;
        E[a].push_back(b);
        E[b].push_back(a);
    }
    int visited = DFS(1);
    return visited == n;
}


int main() {
    scanf("%d", &n);
    vector<pair<int, int> > current_edges;
    vector<pair<int, int> > result_edges;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        current_edges.emplace_back(a, b);
    }
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        result_edges.emplace_back(a, b);
    }
    vector<tuple<int, int, int, int>> ans;
    for (int i = 0; i < n - 1; i++) {
        if (find(result_edges.begin(), result_edges.end(), current_edges[i]) == result_edges.end()) {
            bool found = false;
            for (int j = 0; j < n - 1; j++) {
                if (find(current_edges.begin(), current_edges.end(), result_edges[j]) == current_edges.end()) {
                    pair<int, int> tmp = current_edges[i];
                    current_edges[i] = result_edges[j];
                    if (is_tree(current_edges)) {
                        ans.emplace_back(tmp.first, tmp.second, current_edges[i].first, current_edges[i].second);
                        found = true;
                        break;
                    }
                    current_edges[i] = tmp;
                }
            }
            assert(found);
        }
    }
    printf("%d\n", (int)ans.size());
    for (auto oper : ans) {
        int a, b, c, d;
        tie(a, b, c, d) = oper;
        printf("%d %d %d %d\n", a, b, c, d);
    }
}
