#include <cstdio>
#include <vector>
#include <cassert>
#include <cstring>

#define next next_i_love_std
using namespace std;

const int MAXN = 500001;

int next[2][2 * MAXN];
int to[2][2 * MAXN];
int first[2][MAXN];
int last[2][MAXN];

vector<pair<int, int>> ans;
int used[MAXN];
int dsu[MAXN];

int get(int v) {
  if (dsu[v] == v) return v;
  return dsu[v] = get(dsu[v]);
}

void dfs(int v, int p) {
  //fprintf(stderr, "in %d\n", v + 1);
  int pid = -1;
  for (int i = first[0][v]; i != -1; i = next[0][i]) {
    if (to[0][i] != p) {
      dfs(to[0][i], v);
    } else {
      pid = i;
    }
  }
  //fprintf(stderr, "doing %d\n", v + 1);
  if (pid == -1) return;

  for (int &i = first[1][v]; i != -1; i = next[1][i]) {
    if (used[i / 2]) {
      //fprintf(stderr, "edge %d<->%d already added\n", to[1][i] + 1, to[1][i ^ 1] + 1);
      continue;
    }
    used[i / 2] = 1;
    if (min(to[1][i], to[1][i ^ 1]) != min(to[0][pid], to[0][pid ^ 1]) || 
        max(to[1][i], to[1][i ^ 1]) != max(to[0][pid], to[0][pid ^ 1])) {
      ans.push_back(make_pair(pid, i));
    }
    assert(next[1][last[1][v]] == -1);
    int merge_to = get(to[1][i]);
    next[1][last[1][v]] = first[1][merge_to];  
    first[1][merge_to] = i;
    dsu[v] = merge_to;
    //fprintf(stderr, "found edge %d<->%d\n", to[1][i] + 1, to[1][i^1] + 1);
    return;
  }
  assert(0);
}

int main() {
  int n;
  scanf("%d",&n);
  memset(next, -1, sizeof(next));
  memset(to, -1, sizeof(to));
  memset(first, -1, sizeof(first));
  memset(last, -1, sizeof(last));
  for (int g = 0; g < 2; g++) {
    for (int i = 0; i < n - 1; i++) {
      int a, b;
      scanf("%d%d",&a,&b);
      --a, --b;
      to[g][2*i] = b;
      to[g][2*i + 1] = a;
      next[g][2*i] = first[g][a];
      first[g][a] = 2*i;
      next[g][2*i + 1] = first[g][b];
      first[g][b] = 2*i + 1;
      if (last[g][a] == -1) last[g][a] = first[g][a];
      if (last[g][b] == -1) last[g][b] = first[g][b];
    }
  }

  for (int i = 0; i < n; i++) {
    dsu[i] = i;
  }
  dfs(0, -1);

  printf("%d\n", (int)ans.size());
  for (int i = 0; i < (int)ans.size(); i++) {
    int a = ans[i].first;
    int b = ans[i].second;
    printf("%d %d %d %d\n", to[0][a] + 1, to[0][a^1] + 1, to[1][b] + 1, to[1][b^1] + 1);
  }
  return 0;
}
